const Compiler = require('../src/compiler')
const Lexer = require('../src/lexer')
const Parser = require('../src/parser')

const scan = source => {
  const lexer = new Lexer()
  return lexer.scan(source)
}

const parse = source => {
  const parser = new Parser(scan(source))
  return parser.parse()
}

const compile = source => {
  const compiler = new Compiler()
  return compiler.compile(parse(source))
}

module.exports = {
  compile: compile,
  parse: parse,
  scan: scan,
}
